diff --git a/src/backend/commands/analyze.c b/src/backend/commands/analyze.c
index 9cd6e67..1ac9b5a 100644
--- a/src/backend/commands/analyze.c
+++ b/src/backend/commands/analyze.c
@@ -1776,12 +2074,19 @@ typedef struct
 	int		   *tupnoLink;
 } CompareScalarsContext;
 
+typedef struct
+{
+	SortSupport		ssup;
+	FmgrInfo		cmpFn; /* FIXME: this should be somewhere else? */
+} CompareDatumsContext;
 
-static void compute_minimal_stats(VacAttrStatsP stats,
+static void compute_minimal_stats(VacStatsP stats,
+					  int index,
 					  AnalyzeAttrFetchFunc fetchfunc,
 					  int samplerows,
 					  double totalrows);
-static void compute_scalar_stats(VacAttrStatsP stats,
+static void compute_scalar_stats(VacStatsP stats,
+					 int index,
 					 AnalyzeAttrFetchFunc fetchfunc,
 					 int samplerows,
 					 double totalrows);
@@ -1793,20 +2098,19 @@ static int	compare_mcvs(const void *a, const void *b);
  * std_typanalyze -- the default type-specific typanalyze function
  */
 bool
-std_typanalyze(VacAttrStats *stats)
+std_typanalyze(VacStats *stats, int index)
 {
-	Form_pg_attribute attr = stats->attr;
 	Oid			ltopr;
 	Oid			eqopr;
 	StdAnalyzeData *mystats;
 
-	/* If the attstattarget column is negative, use the default value */
+	/* If the statarget column is negative, use the default value */
 	/* NB: it is okay to scribble on stats->attr since it's a copy */
-	if (attr->attstattarget < 0)
-		attr->attstattarget = default_statistics_target;
+	if (stats->statarget < 0)
+		stats->statarget = default_statistics_target;
 
 	/* Look for default "<" and "=" operators for column's type */
-	get_sort_group_operators(stats->attrtypid,
+	get_sort_group_operators(stats->attrtypids[index],
 							 false, false, false,
 							 &ltopr, &eqopr, NULL,
 							 NULL);
@@ -1820,7 +2124,7 @@ std_typanalyze(VacAttrStats *stats)
 	mystats->eqopr = eqopr;
 	mystats->eqfunc = get_opcode(eqopr);
 	mystats->ltopr = ltopr;
-	stats->extra_data = mystats;
+	stats->extra_data[index] = mystats;
 
 	/*
 	 * Determine which standard statistics algorithm to use
@@ -1828,7 +2132,8 @@ std_typanalyze(VacAttrStats *stats)
 	if (OidIsValid(ltopr))
 	{
 		/* Seems to be a scalar datatype */
-		stats->compute_stats = compute_scalar_stats;
+		stats->statfuncs[index].compute_func_ptr = compute_scalar_stats;
+		stats->statfuncs[index].findval_func_ptr = ordered_findval;
 		/*--------------------
 		 * The following choice of minrows is based on the paper
 		 * "Random sampling for histogram construction: how much is enough?"
@@ -1848,14 +2153,15 @@ std_typanalyze(VacAttrStats *stats)
 		 * know it at this point.
 		 *--------------------
 		 */
-		stats->minrows = 300 * attr->attstattarget;
+		stats->minrows = 300 * stats->statarget;
 	}
 	else
 	{
 		/* Can't do much but the minimal stuff */
-		stats->compute_stats = compute_minimal_stats;
+		stats->statfuncs[index].compute_func_ptr = compute_minimal_stats;
+		stats->statfuncs[index].findval_func_ptr = unordered_findval;
 		/* Might as well use the same minrows as above */
-		stats->minrows = 300 * attr->attstattarget;
+		stats->minrows = 300 * stats->statarget;
 	}
 
 	return true;
@@ -1877,7 +2183,8 @@ std_typanalyze(VacAttrStats *stats)
  *	depend mainly on the length of the list we are willing to keep.
  */
 static void
-compute_minimal_stats(VacAttrStatsP stats,
+compute_minimal_stats(VacStatsP stats,
+					  int index,
 					  AnalyzeAttrFetchFunc fetchfunc,
 					  int samplerows,
 					  double totalrows)
@@ -1887,10 +2194,10 @@ compute_minimal_stats(VacAttrStatsP stats,
 	int			nonnull_cnt = 0;
 	int			toowide_cnt = 0;
 	double		total_width = 0;
-	bool		is_varlena = (!stats->attrtype->typbyval &&
-							  stats->attrtype->typlen == -1);
-	bool		is_varwidth = (!stats->attrtype->typbyval &&
-							   stats->attrtype->typlen < 0);
+	bool		is_varlena = (!stats->attrtypes[index]->typbyval &&
+							  stats->attrtypes[index]->typlen == -1);
+	bool		is_varwidth = (!stats->attrtypes[index]->typbyval &&
+							   stats->attrtypes[index]->typlen < 0);
 	FmgrInfo	f_cmpeq;
 	typedef struct
 	{
@@ -1900,8 +2207,8 @@ compute_minimal_stats(VacAttrStatsP stats,
 	TrackItem  *track;
 	int			track_cnt,
 				track_max;
-	int			num_mcv = stats->attr->attstattarget;
-	StdAnalyzeData *mystats = (StdAnalyzeData *) stats->extra_data;
+	int			num_mcv = stats->statarget;
+	StdAnalyzeData *mystats = (StdAnalyzeData *) stats->extra_data[index];
 
 	/*
 	 * We track up to 2*n values for an n-element MCV list; but at least 10
@@ -1924,7 +2231,7 @@ compute_minimal_stats(VacAttrStatsP stats,
 
 		vacuum_delay_point();
 
-		value = fetchfunc(stats, i, &isnull);
+		value = fetchfunc(stats, i, stats->attnums->values[index], &isnull);
 
 		/* Check for null/nonnull */
 		if (isnull)
@@ -2021,11 +2328,11 @@ compute_minimal_stats(VacAttrStatsP stats,
 
 		stats->stats_valid = true;
 		/* Do the simple null-frac and width stats */
-		stats->stanullfrac = (double) null_cnt / (double) samplerows;
+		stats->stanullfrac[index] = (double) null_cnt / (double) samplerows;
 		if (is_varwidth)
-			stats->stawidth = total_width / (double) nonnull_cnt;
+			stats->stawidth[index] = total_width / (double) nonnull_cnt;
 		else
-			stats->stawidth = stats->attrtype->typlen;
+			stats->stawidth[index] = stats->attrtypes[index]->typlen;
 
 		/* Count the number of values we found multiple times */
 		summultiple = 0;
@@ -2039,7 +2346,7 @@ compute_minimal_stats(VacAttrStatsP stats,
 		if (nmultiple == 0)
 		{
 			/* If we found no repeated values, assume it's a unique column */
-			stats->stadistinct = -1.0;
+			stats->stadistinct[index] = -1.0;
 		}
 		else if (track_cnt < track_max && toowide_cnt == 0 &&
 				 nmultiple == track_cnt)
@@ -2049,7 +2356,7 @@ compute_minimal_stats(VacAttrStatsP stats,
 			 * value appeared more than once.  Assume the column has just
 			 * these values.
 			 */
-			stats->stadistinct = track_cnt;
+			stats->stadistinct[index] = track_cnt;
 		}
 		else
 		{
@@ -2088,7 +2395,7 @@ compute_minimal_stats(VacAttrStatsP stats,
 				stadistinct = (double) d;
 			if (stadistinct > totalrows)
 				stadistinct = totalrows;
-			stats->stadistinct = floor(stadistinct + 0.5);
+			stats->stadistinct[index] = floor(stadistinct + 0.5);
 		}
 
 		/*
@@ -2097,8 +2404,8 @@ compute_minimal_stats(VacAttrStatsP stats,
 		 * stadistinct should scale with the row count rather than be a fixed
 		 * value.
 		 */
-		if (stats->stadistinct > 0.1 * totalrows)
-			stats->stadistinct = -(stats->stadistinct / totalrows);
+		if (stats->stadistinct[index] > 0.1 * totalrows)
+			stats->stadistinct[index] = -(stats->stadistinct[index] / totalrows);
 
 		/*
 		 * Decide how many values are worth storing as most-common values. If
@@ -2118,7 +2425,7 @@ compute_minimal_stats(VacAttrStatsP stats,
 		}
 		else
 		{
-			double		ndistinct = stats->stadistinct;
+			double		ndistinct = stats->stadistinct[index];
 			double		avgcount,
 						mincount;
 
@@ -2156,18 +2463,18 @@ compute_minimal_stats(VacAttrStatsP stats,
 			for (i = 0; i < num_mcv; i++)
 			{
 				mcv_values[i] = datumCopy(track[i].value,
-										  stats->attrtype->typbyval,
-										  stats->attrtype->typlen);
+										  stats->attrtypes[index]->typbyval,
+										  stats->attrtypes[index]->typlen);
 				mcv_freqs[i] = (double) track[i].count / (double) samplerows;
 			}
 			MemoryContextSwitchTo(old_context);
 
-			stats->stakind[0] = STATISTIC_KIND_MCV;
-			stats->staop[0] = mystats->eqopr;
-			stats->stanumbers[0] = mcv_freqs;
-			stats->numnumbers[0] = num_mcv;
-			stats->stavalues[0] = mcv_values;
-			stats->numvalues[0] = num_mcv;
+			stats->stakind[index][0] = STATISTIC_KIND_MCV;
+			stats->staop[index][0] = mystats->eqopr;
+			stats->stanumbers[index][0] = mcv_freqs;
+			stats->numnumbers[index][0] = num_mcv;
+			stats->stavalues[index][0] = mcv_values;
+			stats->numvalues[index][0] = num_mcv;
 
 			/*
 			 * Accept the defaults for stats->statypid and others. They have
@@ -2179,12 +2486,12 @@ compute_minimal_stats(VacAttrStatsP stats,
 	{
 		/* We found only nulls; assume the column is entirely null */
 		stats->stats_valid = true;
-		stats->stanullfrac = 1.0;
+		stats->stanullfrac[index] = 1.0;
 		if (is_varwidth)
-			stats->stawidth = 0;	/* "unknown" */
+			stats->stawidth[index] = 0;	/* "unknown" */
 		else
-			stats->stawidth = stats->attrtype->typlen;
-		stats->stadistinct = 0.0;		/* "unknown" */
+			stats->stawidth[index] = stats->attrtypes[index]->typlen;
+		stats->stadistinct[index] = 0.0;	/* "unknown" */
 	}
 
 	/* We don't need to bother cleaning up any of our temporary palloc's */
@@ -2204,7 +2511,8 @@ compute_minimal_stats(VacAttrStatsP stats,
  *	data values into order.
  */
 static void
-compute_scalar_stats(VacAttrStatsP stats,
+compute_scalar_stats(VacStatsP stats,
+					 int index,
 					 AnalyzeAttrFetchFunc fetchfunc,
 					 int samplerows,
 					 double totalrows)
@@ -2214,10 +2522,10 @@ compute_scalar_stats(VacAttrStatsP stats,
 	int			nonnull_cnt = 0;
 	int			toowide_cnt = 0;
 	double		total_width = 0;
-	bool		is_varlena = (!stats->attrtype->typbyval &&
-							  stats->attrtype->typlen == -1);
-	bool		is_varwidth = (!stats->attrtype->typbyval &&
-							   stats->attrtype->typlen < 0);
+	bool		is_varlena = (!stats->attrtypes[index]->typbyval &&
+							  stats->attrtypes[index]->typlen == -1);
+	bool		is_varwidth = (!stats->attrtypes[index]->typbyval &&
+							   stats->attrtypes[index]->typlen < 0);
 	double		corr_xysum;
 	SortSupportData ssup;
 	ScalarItem *values;
@@ -2225,9 +2533,9 @@ compute_scalar_stats(VacAttrStatsP stats,
 	int		   *tupnoLink;
 	ScalarMCVItem *track;
 	int			track_cnt = 0;
-	int			num_mcv = stats->attr->attstattarget;
-	int			num_bins = stats->attr->attstattarget;
-	StdAnalyzeData *mystats = (StdAnalyzeData *) stats->extra_data;
+	int			num_mcv = stats->statarget;
+	int			num_bins = stats->statarget;
+	StdAnalyzeData *mystats = (StdAnalyzeData *) stats->extra_data[index];
 
 	values = (ScalarItem *) palloc(samplerows * sizeof(ScalarItem));
 	tupnoLink = (int *) palloc(samplerows * sizeof(int));
@@ -2249,7 +2557,7 @@ compute_scalar_stats(VacAttrStatsP stats,
 
 		vacuum_delay_point();
 
-		value = fetchfunc(stats, i, &isnull);
+		value = fetchfunc(stats, i, stats->attnums->values[index], &isnull);
 
 		/* Check for null/nonnull */
 		if (isnull)
@@ -2378,16 +2686,16 @@ compute_scalar_stats(VacAttrStatsP stats,
 
 		stats->stats_valid = true;
 		/* Do the simple null-frac and width stats */
-		stats->stanullfrac = (double) null_cnt / (double) samplerows;
+		stats->stanullfrac[index] = (double) null_cnt / (double) samplerows;
 		if (is_varwidth)
-			stats->stawidth = total_width / (double) nonnull_cnt;
+			stats->stawidth[index] = total_width / (double) nonnull_cnt;
 		else
-			stats->stawidth = stats->attrtype->typlen;
+			stats->stawidth[index] = stats->attrtypes[index]->typlen;
 
 		if (nmultiple == 0)
 		{
 			/* If we found no repeated values, assume it's a unique column */
-			stats->stadistinct = -1.0;
+			stats->stadistinct[index] = -1.0;
 		}
 		else if (toowide_cnt == 0 && nmultiple == ndistinct)
 		{
@@ -2395,7 +2703,7 @@ compute_scalar_stats(VacAttrStatsP stats,
 			 * Every value in the sample appeared more than once.  Assume the
 			 * column has just these values.
 			 */
-			stats->stadistinct = ndistinct;
+			stats->stadistinct[index] = ndistinct;
 		}
 		else
 		{
@@ -2430,7 +2738,7 @@ compute_scalar_stats(VacAttrStatsP stats,
 				stadistinct = (double) d;
 			if (stadistinct > totalrows)
 				stadistinct = totalrows;
-			stats->stadistinct = floor(stadistinct + 0.5);
+			stats->stadistinct[index] = floor(stadistinct + 0.5);
 		}
 
 		/*
@@ -2439,8 +2747,8 @@ compute_scalar_stats(VacAttrStatsP stats,
 		 * stadistinct should scale with the row count rather than be a fixed
 		 * value.
 		 */
-		if (stats->stadistinct > 0.1 * totalrows)
-			stats->stadistinct = -(stats->stadistinct / totalrows);
+		if (stats->stadistinct[index] > 0.1 * totalrows)
+			stats->stadistinct[index] = -(stats->stadistinct[index] / totalrows);
 
 		/*
 		 * Decide how many values are worth storing as most-common values. If
@@ -2457,7 +2765,7 @@ compute_scalar_stats(VacAttrStatsP stats,
 		 * but we prefer to treat such values as MCVs if at all possible.)
 		 */
 		if (track_cnt == ndistinct && toowide_cnt == 0 &&
-			stats->stadistinct > 0 &&
+			stats->stadistinct[index] > 0 &&
 			track_cnt <= num_mcv)
 		{
 			/* Track list includes all values seen, and all will fit */
@@ -2465,7 +2773,7 @@ compute_scalar_stats(VacAttrStatsP stats,
 		}
 		else
 		{
-			double		ndistinct = stats->stadistinct;
+			double		ndistinct = stats->stadistinct[index];
 			double		avgcount,
 						mincount,
 						maxmincount;
@@ -2508,18 +2816,18 @@ compute_scalar_stats(VacAttrStatsP stats,
 			for (i = 0; i < num_mcv; i++)
 			{
 				mcv_values[i] = datumCopy(values[track[i].first].value,
-										  stats->attrtype->typbyval,
-										  stats->attrtype->typlen);
+										  stats->attrtypes[index]->typbyval,
+										  stats->attrtypes[index]->typlen);
 				mcv_freqs[i] = (double) track[i].count / (double) samplerows;
 			}
 			MemoryContextSwitchTo(old_context);
 
-			stats->stakind[slot_idx] = STATISTIC_KIND_MCV;
-			stats->staop[slot_idx] = mystats->eqopr;
-			stats->stanumbers[slot_idx] = mcv_freqs;
-			stats->numnumbers[slot_idx] = num_mcv;
-			stats->stavalues[slot_idx] = mcv_values;
-			stats->numvalues[slot_idx] = num_mcv;
+			stats->stakind[index][slot_idx] = STATISTIC_KIND_MCV;
+			stats->staop[index][slot_idx] = mystats->eqopr;
+			stats->stanumbers[index][slot_idx] = mcv_freqs;
+			stats->numnumbers[index][slot_idx] = num_mcv;
+			stats->stavalues[index][slot_idx] = mcv_values;
+			stats->numvalues[index][slot_idx] = num_mcv;
 
 			/*
 			 * Accept the defaults for stats->statypid and others. They have
@@ -2615,8 +2923,8 @@ compute_scalar_stats(VacAttrStatsP stats,
 			for (i = 0; i < num_hist; i++)
 			{
 				hist_values[i] = datumCopy(values[pos].value,
-										   stats->attrtype->typbyval,
-										   stats->attrtype->typlen);
+										   stats->attrtypes[index]->typbyval,
+										   stats->attrtypes[index]->typlen);
 				pos += delta;
 				posfrac += deltafrac;
 				if (posfrac >= (num_hist - 1))
@@ -2629,10 +2937,10 @@ compute_scalar_stats(VacAttrStatsP stats,
 
 			MemoryContextSwitchTo(old_context);
 
-			stats->stakind[slot_idx] = STATISTIC_KIND_HISTOGRAM;
-			stats->staop[slot_idx] = mystats->ltopr;
-			stats->stavalues[slot_idx] = hist_values;
-			stats->numvalues[slot_idx] = num_hist;
+			stats->stakind[index][slot_idx] = STATISTIC_KIND_HISTOGRAM;
+			stats->staop[index][slot_idx] = mystats->ltopr;
+			stats->stavalues[index][slot_idx] = hist_values;
+			stats->numvalues[index][slot_idx] = num_hist;
 
 			/*
 			 * Accept the defaults for stats->statypid and others. They have
@@ -2672,10 +2980,10 @@ compute_scalar_stats(VacAttrStatsP stats,
 			corrs[0] = (values_cnt * corr_xysum - corr_xsum * corr_xsum) /
 				(values_cnt * corr_x2sum - corr_xsum * corr_xsum);
 
-			stats->stakind[slot_idx] = STATISTIC_KIND_CORRELATION;
-			stats->staop[slot_idx] = mystats->ltopr;
-			stats->stanumbers[slot_idx] = corrs;
-			stats->numnumbers[slot_idx] = 1;
+			stats->stakind[index][slot_idx] = STATISTIC_KIND_CORRELATION;
+			stats->staop[index][slot_idx] = mystats->ltopr;
+			stats->stanumbers[index][slot_idx] = corrs;
+			stats->numnumbers[index][slot_idx] = 1;
 			slot_idx++;
 		}
 	}
@@ -2683,12 +2991,12 @@ compute_scalar_stats(VacAttrStatsP stats,
 	{
 		/* We found only nulls; assume the column is entirely null */
 		stats->stats_valid = true;
-		stats->stanullfrac = 1.0;
+		stats->stanullfrac[index] = 1.0;
 		if (is_varwidth)
-			stats->stawidth = 0;	/* "unknown" */
+			stats->stawidth[index] = 0;	/* "unknown" */
 		else
-			stats->stawidth = stats->attrtype->typlen;
-		stats->stadistinct = 0.0;		/* "unknown" */
+			stats->stawidth[index] = stats->attrtypes[index]->typlen;
+		stats->stadistinct[index] = 0.0;	/* "unknown" */
 	}
 
 	/* We don't need to bother cleaning up any of our temporary palloc's */
@@ -2732,6 +3040,209 @@ compare_scalars(const void *a, const void *b, void *arg)
 }
 
 /*
+ * qsort_arg comparator for cross column statistics
+ * The dimension axes need to be properly ordered.
+ */
+static int
+compare_datums(const void *a, const void *b, void *arg)
+{
+	Datum		da = *((Datum *) a);
+	Datum		db = *((Datum *) b);
+	CompareDatumsContext *ctx = (CompareDatumsContext *) arg;
+
+	return ApplySortComparator(da, false, db, false, ctx->ssup);
+}
+
+/*
+ * Find the index in stavalues for a Datum with ordering operators.
+ * Because it's ordered, we can use the ordering operator for binary searching.
+ * Returns: 0 for a NULL value, 1 for a non MCV value, >= 2 for a valid index.
+ */
+static int
+ordered_findval(VacStatsP stats, int rownum, int index, AnalyzeAttrFetchFunc fetchfunc, void *arg)
+{
+	Datum		value;
+	bool		isnull;
+	int		idx_lo, idx_hi, idx_mid;
+	int32		compare;
+	CompareDatumsContext *ctx = (CompareDatumsContext *) arg;
+
+	value = fetchfunc(stats, rownum, stats->attnums->values[index], &isnull);
+	if (isnull)
+		return 0;
+
+	idx_lo = 0;
+	idx_hi = stats->numvalues[index][0] - 1;
+
+	idx_mid = (idx_lo + idx_hi) / 2;
+	while (idx_lo <= idx_hi)
+	{
+		compare = ApplySortComparator(value, false,
+								stats->stavalues[index][0][idx_mid], false, ctx->ssup);
+		if (compare == 0)
+			break;
+		else if (compare < 0)
+			idx_hi = idx_mid - 1;
+		else /* compare > 0 */
+			idx_lo = idx_mid + 1;
+
+		idx_mid = (idx_lo + idx_hi) / 2;
+	}
+
+	if (compare == 0)
+		return idx_mid + 2;
+
+	/* Not found, return "other" special slot */
+	return 1;
+}
+
+/*
+ * Find the index in stavalues for a Datum with equality operator only.
+ * Byte the bullet and loop through the stavalues array.
+ * Returns: 0 for NULL value, >= 2 for a valid index and 1 for a Datum
+ * that isn't in stavalues ("other" value).
+ */
+static int
+unordered_findval(VacStatsP stats, int rownum, int index, AnalyzeAttrFetchFunc fetchfunc, void *arg)
+{
+	CompareDatumsContext *ctx = (CompareDatumsContext *) arg;
+	Datum		value;
+	bool		isnull;
+	int		i;
+
+	/* FIXME: Assert ctx->cmpFn is correct */
+
+	value = fetchfunc(stats, rownum, stats->attnums->values[index], &isnull);
+	if (isnull)
+		return 0;
+
+	for (i = 0; i < stats->numvalues[index][0]; i++)
+	{
+		if (DatumGetBool(FunctionCall2Coll(&(ctx->cmpFn),
+								DEFAULT_COLLATION_OID,
+								value, stats->stavalues[index][0][i])))
+			return i + 2;
+	}
+
+	return 1;
+}
+
+/*
+ * Compute a cross-column statistics.
+ */
+static void
+compute_cross_column_stats(VacStatsP stats, AnalyzeAttrFetchFunc fetchfunc, int numrows)
+{
+	int			i, j, numvalues;
+	int			dimstride[STATISTIC_NUM_SLOTS];
+	MemoryContext		old_context;
+	CompareDatumsContext	ctx[STATISTIC_NUM_SLOTS];
+	float4		   *hist;
+
+	/* Don't touch single column statistics. */
+	if (stats->attnums->dim1 == 1)
+		return;
+
+	/*
+	 * Don't compute cross-column statistics if there is no way to find
+	 * a Datum's index in the stavalues[] array
+	 */
+	for (i = 0; i < stats->attnums->dim1; i++)
+		if (stats->statfuncs[i].findval_func_ptr == NULL)
+			return;
+
+	/* We need ordered stavalues arrays whenever possible. */
+	for (i = 0; i < stats->attnums->dim1; i++)
+	{
+		StdAnalyzeData *mystats = (StdAnalyzeData *) stats->extra_data[i];
+
+		if (OidIsValid(mystats->ltopr))
+		{
+			Oid	cmpFn;
+			SortSupportData *ssup;
+			/* FIXME: shouldn't be necessary in this case */
+			bool reverse, issupport;
+
+			if (!get_sort_function_for_ordering_op(mystats->ltopr, &cmpFn,
+					&issupport, &reverse)) {
+				elog(ERROR, "operator %u is not a valid ordering operator",
+						mystats->ltopr);
+			}
+			fmgr_info(cmpFn, &(ctx[i].cmpFn));
+
+			ssup = (SortSupportData*) palloc0(sizeof(SortSupportData));
+			ssup->ssup_cxt = CurrentMemoryContext;
+			/* We always use the default collation for statistics */
+			ssup->ssup_collation = DEFAULT_COLLATION_OID;
+			ssup->ssup_nulls_first = false;
+
+			PrepareSortSupportFromOrderingOp(mystats->ltopr, ssup);
+
+			ctx[i].ssup = ssup;
+
+			qsort_arg((void *) stats->stavalues[i][0], stats->numvalues[i][0], sizeof(Datum),
+										  compare_datums, (void *) &ctx[i]);
+		}
+		else
+			fmgr_info(mystats->eqfunc, &(ctx[i].cmpFn));
+	}
+
+	/* Free up previously computed stanumbers arrays. */
+	for (i = 0; i < STATISTIC_NUM_SLOTS; i++)
+		for (j = 0; j < STATISTIC_NUM_SLOTS; j++)
+		{
+			if (stats->stanumbers[i][j])
+			{
+				pfree(stats->stanumbers[i][j]);
+				stats->stanumbers[i][j] = NULL;
+			}
+			stats->numnumbers[i][j] = 0;
+		}
+
+	/*
+	 * Compute the size of the N-dimension histogram and the dimension stride values.
+	 * The histogram cells at the 0th index of a dimension is the nullfrac value,
+	 * hence the + 1.
+	 */
+	for (i = 0, numvalues = 1; i < stats->attnums->dim1; i++)
+	{
+		dimstride[stats->attnums->dim1 - i - 1] = numvalues;
+		numvalues *= stats->numvalues[stats->attnums->dim1 - i - 1][0] + 2;
+	}
+
+	old_context = MemoryContextSwitchTo(stats->anl_context);
+
+	hist = (float *) palloc(numvalues * sizeof(float));
+	for (i = 0; i < numvalues; i++)
+		hist[i] = 0.0;
+
+	MemoryContextSwitchTo(old_context);
+
+	for (i = 0; i < numrows; i++)
+	{
+		int	idx, idx_tmp;
+
+		idx = 0;
+		for (j = 0; j < stats->attnums->dim1; j++)
+		{
+			idx_tmp = stats->statfuncs[j].findval_func_ptr(stats, i, j, fetchfunc, &ctx[j]);
+			if (idx_tmp < 0)
+				continue;
+
+			idx += idx_tmp * dimstride[j];
+		}
+		hist[idx] = hist[idx] + 1.0;
+	}
+
+	/* Store selectivity instead of actual counts. */
+	for (i = 0; i < numvalues; i ++)
+		hist[i] /= numrows;
+
+	stats->numnumbers[0][0] = numvalues;
+	stats->stanumbers[0][0] = hist;
+}
+
+/*
  * qsort comparator for sorting ScalarMCVItems by position
  */
 static int
@@ -2742,3 +3253,74 @@ compare_mcvs(const void *a, const void *b)
 
 	return da - db;
 }
+
+/*
+ * ExtraColStat
+ *     Add or remove one extra entry in pg_statistics
+ */
+void ExtraStatistics(ExtraStatStmt *stmt)
+{
+	Oid		relId;
+	int		len, i, j;
+	bool		differ = false;
+	AttrNumber	   *attnums;
+	AttrNumber	   *sorted_attnums;
+	ListCell	   *l;
+
+	relId = RangeVarGetRelid(stmt->relation, AccessExclusiveLock, false);
+
+	len = list_length(stmt->columns);
+	if (len < 2)
+		elog(ERROR, "cross column statistics need at least two columns");
+	if (len > STATISTIC_NUM_SLOTS)
+		elog(ERROR, "cross column statistics can cover at most %d columns", STATISTIC_NUM_SLOTS);
+
+	attnums = (int2 *)palloc(len * sizeof(AttrNumber));
+	sorted_attnums = (int2 *)palloc(len * sizeof(AttrNumber));
+
+	i = 0;
+	foreach(l, stmt->columns)
+	{
+		Node	   *node = (Node *) lfirst(l);
+		Var	   *var;
+
+		if (!IsA(node, Var))
+			elog(ERROR, "not a column reference");
+
+		var = (Var *) node;
+
+		if (var->varattno == 0)
+			elog(ERROR, "row expansion via \"*\" is not supported here");
+
+		sorted_attnums[i] = attnums[i] = var->varattno;
+
+		i++;
+	}
+
+	for (i = 0;  i < len - 1; i++)
+		for (j = i+1; j < len; j++)
+			if (sorted_attnums[i] > sorted_attnums[j])
+			{
+				AttrNumber	tmp = sorted_attnums[i];
+
+				sorted_attnums[i] = sorted_attnums[j];
+				sorted_attnums[j] = tmp;
+			}
+
+	for (i = 0; i < len; i++)
+	{
+		if (!differ && attnums[i] != sorted_attnums[i])
+			differ = true;
+
+		if ((i < len - 1) && sorted_attnums[i] == sorted_attnums[i+1])
+			elog(ERROR, "column list must contain every column exactly once");
+
+	}
+	if (differ)
+		elog(WARNING, "the column list was reordered in the order of table attributes");
+
+	if (stmt->create)
+		AddStatistics(relId, sorted_attnums, len, false, stmt->statistics_target);
+	else
+		RemoveStatistics(relId, sorted_attnums, len);
+}
diff --git a/src/backend/commands/tablecmds.c b/src/backend/commands/tablecmds.c
index cd4490a..4ab4b4c 100644
--- a/src/backend/commands/tablecmds.c
+++ b/src/backend/commands/tablecmds.c
@@ -35,6 +35,7 @@
 #include "catalog/pg_inherits_fn.h"
 #include "catalog/pg_namespace.h"
 #include "catalog/pg_opclass.h"
+#include "catalog/pg_statistic.h"
 #include "catalog/pg_tablespace.h"
 #include "catalog/pg_trigger.h"
 #include "catalog/pg_type.h"
@@ -4342,7 +4343,6 @@ ATExecAddColumn(List **wqueue, AlteredTableInfo *tab, Relation rel,
 	attribute.attrelid = myrelid;
 	namestrcpy(&(attribute.attname), colDef->colname);
 	attribute.atttypid = typeOid;
-	attribute.attstattarget = (newattnum > 0) ? -1 : 0;
 	attribute.attlen = tform->typlen;
 	attribute.attcacheoff = -1;
 	attribute.atttypmod = typmod;
@@ -4504,6 +4504,8 @@ ATExecAddColumn(List **wqueue, AlteredTableInfo *tab, Relation rel,
 	add_column_datatype_dependency(myrelid, newattnum, attribute.atttypid);
 	add_column_collation_dependency(myrelid, newattnum, attribute.attcollation);
 
+	AddStatistics(myrelid, &attribute.attnum, 1, attribute.attinhcount, (newattnum > 0) ? -1 : 0);
+
 	/*
 	 * Propagate to children as appropriate.  Unlike most other ALTER
 	 * routines, we have to do this one level of recursion at a time; we can't
@@ -4885,8 +4887,14 @@ ATExecSetStatistics(Relation rel, const char *colName, Node *newValue, LOCKMODE
 {
 	int			newtarget;
 	Relation	attrelation;
+	Relation	statsrelation;
+	Oid		relid;
 	HeapTuple	tuple;
 	Form_pg_attribute attrtuple;
+	AttrNumber	attnum;
+	bool		inherited;
+	int2vector *attnumvector;
+	Form_pg_statistic stattuple;
 
 	Assert(IsA(newValue, Integer));
 	newtarget = intVal(newValue);
@@ -4912,7 +4920,9 @@ ATExecSetStatistics(Relation rel, const char *colName, Node *newValue, LOCKMODE
 
 	attrelation = heap_open(AttributeRelationId, RowExclusiveLock);
 
-	tuple = SearchSysCacheCopyAttName(RelationGetRelid(rel), colName);
+	relid = RelationGetRelid(rel);
+
+	tuple = SearchSysCacheAttName(relid, colName);
 
 	if (!HeapTupleIsValid(tuple))
 		ereport(ERROR,
@@ -4927,16 +4937,41 @@ ATExecSetStatistics(Relation rel, const char *colName, Node *newValue, LOCKMODE
 				 errmsg("cannot alter system column \"%s\"",
 						colName)));
 
-	attrtuple->attstattarget = newtarget;
+	attnum = attrtuple->attnum;
+	inherited = (attrtuple->attinhcount > 0);
 
-	simple_heap_update(attrelation, &tuple->t_self, tuple);
+	ReleaseSysCache(tuple);
 
-	/* keep system catalog indexes current */
-	CatalogUpdateIndexes(attrelation, tuple);
+	heap_close(attrelation, RowExclusiveLock);
 
-	heap_freetuple(tuple);
+	statsrelation = heap_open(StatisticRelationId, RowExclusiveLock);
 
-	heap_close(attrelation, RowExclusiveLock);
+	attnumvector = buildint2vector(&attnum, 1);
+
+	tuple = SearchSysCacheCopy3(STATRELATTINH,
+								ObjectIdGetDatum(relid),
+								PointerGetDatum(attnumvector),
+								BoolGetDatum(inherited));
+
+	pfree(attnumvector);
+
+	if (!HeapTupleIsValid(tuple))
+		AddStatistics(relid, &attnum, 1, inherited, newtarget);
+	else
+	{
+		stattuple = (Form_pg_statistic) GETSTRUCT(tuple);
+
+		stattuple->statarget = newtarget;
+
+		simple_heap_update(statsrelation, &tuple->t_self, tuple);
+
+		/* keep system catalog indexes current */
+		CatalogUpdateIndexes(statsrelation, tuple);
+
+		heap_freetuple(tuple);
+	}
+
+	heap_close(statsrelation, RowExclusiveLock);
 }
 
 static void
@@ -7587,9 +7622,9 @@ ATExecAlterColumnType(AlteredTableInfo *tab, Relation rel,
 	add_column_collation_dependency(RelationGetRelid(rel), attnum, targetcollid);
 
 	/*
-	 * Drop any pg_statistic entry for the column, since it's now wrong type
+	 * Invalidate any pg_statistic entry for the column, since it's now wrong type
 	 */
-	RemoveStatistics(RelationGetRelid(rel), attnum);
+	InvalidateStatistics(RelationGetRelid(rel), attnum);
 
 	/*
 	 * Update the default, if present, by brute force --- remove and re-add
diff --git a/src/backend/executor/nodeHash.c b/src/backend/executor/nodeHash.c
index cabe663..38b5f73 100644
--- a/src/backend/executor/nodeHash.c
+++ b/src/backend/executor/nodeHash.c
@@ -31,6 +31,7 @@
 #include "executor/nodeHash.h"
 #include "executor/nodeHashjoin.h"
 #include "miscadmin.h"
+#include "utils/builtins.h"
 #include "utils/dynahash.h"
 #include "utils/memutils.h"
 #include "utils/lsyscache.h"
@@ -1124,6 +1125,7 @@ ExecHashBuildSkewHash(HashJoinTable hashtable, Hash *node, int mcvsToUse)
 	int			nvalues;
 	float4	   *numbers;
 	int			nnumbers;
+	int2vector *attnumvector;
 
 	/* Do nothing if planner didn't identify the outer relation's join key */
 	if (!OidIsValid(node->skewTable))
@@ -1135,10 +1137,23 @@ ExecHashBuildSkewHash(HashJoinTable hashtable, Hash *node, int mcvsToUse)
 	/*
 	 * Try to find the MCV statistics for the outer relation's join key.
 	 */
+	attnumvector = buildint2vector(&(node->skewColumn), 1);
 	statsTuple = SearchSysCache3(STATRELATTINH,
 								 ObjectIdGetDatum(node->skewTable),
-								 Int16GetDatum(node->skewColumn),
+								 PointerGetDatum(attnumvector),
 								 BoolGetDatum(node->skewInherit));
+	pfree(attnumvector);
+
+	/* check whether the stats entry is valid */
+	if (HeapTupleIsValid(statsTuple))
+	{
+		if (!((Form_pg_statistic)GETSTRUCT(statsTuple))->stavalid)
+		{
+			ReleaseSysCache(statsTuple);
+			statsTuple = NULL;
+		}
+	}
+
 	if (!HeapTupleIsValid(statsTuple))
 		return;
 
diff --git a/src/backend/nodes/copyfuncs.c b/src/backend/nodes/copyfuncs.c
index 868fb71..66dc24a 100644
--- a/src/backend/nodes/copyfuncs.c
+++ b/src/backend/nodes/copyfuncs.c
@@ -3422,6 +3422,19 @@ _copyCreateForeignTableStmt(const CreateForeignTableStmt *from)
 	return newnode;
 }
 
+static ExtraStatStmt *
+_copyExtraStatStmt(ExtraStatStmt *from)
+{
+	ExtraStatStmt *newnode = makeNode(ExtraStatStmt);
+
+	COPY_SCALAR_FIELD(create);
+	newnode->relation = _copyRangeVar(from->relation);
+	COPY_NODE_FIELD(columns);
+	COPY_SCALAR_FIELD(statistics_target);
+
+	return newnode;
+}
+
 static CreateTrigStmt *
 _copyCreateTrigStmt(const CreateTrigStmt *from)
 {
@@ -4290,6 +4303,9 @@ copyObject(const void *from)
 		case T_CreateForeignTableStmt:
 			retval = _copyCreateForeignTableStmt(from);
 			break;
+		case T_ExtraStatStmt:
+			retval = _copyExtraStatStmt(from);
+			break;
 		case T_CreateTrigStmt:
 			retval = _copyCreateTrigStmt(from);
 			break;
diff --git a/src/backend/nodes/equalfuncs.c b/src/backend/nodes/equalfuncs.c
index d2a79eb..a7bf2a6 100644
--- a/src/backend/nodes/equalfuncs.c
+++ b/src/backend/nodes/equalfuncs.c
@@ -1758,6 +1758,18 @@ _equalCreateForeignTableStmt(const CreateForeignTableStmt *a, const CreateForeig
 }
 
 static bool
+_equalExtraStatStmt(ExtraStatStmt *a, ExtraStatStmt *b)
+{
+	COMPARE_SCALAR_FIELD(create);
+	if (!_equalRangeVar(a->relation, b->relation))
+		return FALSE;
+	COMPARE_NODE_FIELD(columns);
+	COMPARE_SCALAR_FIELD(statistics_target);
+
+	return true;
+}
+
+static bool
 _equalCreateTrigStmt(const CreateTrigStmt *a, const CreateTrigStmt *b)
 {
 	COMPARE_STRING_FIELD(trigname);
@@ -2850,6 +2862,9 @@ equal(const void *a, const void *b)
 		case T_CreateForeignTableStmt:
 			retval = _equalCreateForeignTableStmt(a, b);
 			break;
+		case T_ExtraStatStmt:
+			retval = _equalExtraStatStmt(a, b);
+			break;
 		case T_CreateTrigStmt:
 			retval = _equalCreateTrigStmt(a, b);
 			break;
